<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetResolvedTroubleConditionsCsvInput StructType
 * @subpackage Structs
 */
class GetResolvedTroubleConditionsCsvInput extends AbstractStructBase
{
    /**
     * The CallerVersion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $CallerVersion;
    /**
     * The CustomerId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $CustomerId;
    /**
     * The IncludeDeviceDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IncludeDeviceDetails;
    /**
     * Constructor method for GetResolvedTroubleConditionsCsvInput
     * @uses GetResolvedTroubleConditionsCsvInput::setCallerVersion()
     * @uses GetResolvedTroubleConditionsCsvInput::setCustomerId()
     * @uses GetResolvedTroubleConditionsCsvInput::setIncludeDeviceDetails()
     * @param int $callerVersion
     * @param int $customerId
     * @param bool $includeDeviceDetails
     */
    public function __construct($callerVersion = null, $customerId = null, $includeDeviceDetails = null)
    {
        $this
            ->setCallerVersion($callerVersion)
            ->setCustomerId($customerId)
            ->setIncludeDeviceDetails($includeDeviceDetails);
    }
    /**
     * Get CallerVersion value
     * @return int
     */
    public function getCallerVersion()
    {
        return $this->CallerVersion;
    }
    /**
     * Set CallerVersion value
     * @param int $callerVersion
     * @return \CustomerManagement\StructType\GetResolvedTroubleConditionsCsvInput
     */
    public function setCallerVersion($callerVersion = null)
    {
        // validation for constraint: int
        if (!is_null($callerVersion) && !(is_int($callerVersion) || ctype_digit($callerVersion))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($callerVersion, true), gettype($callerVersion)), __LINE__);
        }
        $this->CallerVersion = $callerVersion;
        return $this;
    }
    /**
     * Get CustomerId value
     * @return int
     */
    public function getCustomerId()
    {
        return $this->CustomerId;
    }
    /**
     * Set CustomerId value
     * @param int $customerId
     * @return \CustomerManagement\StructType\GetResolvedTroubleConditionsCsvInput
     */
    public function setCustomerId($customerId = null)
    {
        // validation for constraint: int
        if (!is_null($customerId) && !(is_int($customerId) || ctype_digit($customerId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($customerId, true), gettype($customerId)), __LINE__);
        }
        $this->CustomerId = $customerId;
        return $this;
    }
    /**
     * Get IncludeDeviceDetails value
     * @return bool
     */
    public function getIncludeDeviceDetails()
    {
        return $this->IncludeDeviceDetails;
    }
    /**
     * Set IncludeDeviceDetails value
     * @param bool $includeDeviceDetails
     * @return \CustomerManagement\StructType\GetResolvedTroubleConditionsCsvInput
     */
    public function setIncludeDeviceDetails($includeDeviceDetails = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeDeviceDetails) && !is_bool($includeDeviceDetails)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includeDeviceDetails, true), gettype($includeDeviceDetails)), __LINE__);
        }
        $this->IncludeDeviceDetails = $includeDeviceDetails;
        return $this;
    }
}
